
/*
 * Progetto variante del progetto 8 del capitolo 4, 
 * con l'uso di un metodo statico.
 * Si scriva un programma che individua se una parola  palindroma, 
 * cio se scritta nel verso opposto  uguale alla parola di
 * partenza. Anna, ad esempio,  una parola palindroma.
 * Il programma deve terminare quando viene scritta la parola "uscita".
 * 
 */

import java.util.*;

public class TestPalindroma {
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		String parola;
		do {
			System.out.print("Inserire la parola (digitare \"uscita\" per terminare): ");
			parola = tastiera.next().toLowerCase();
			if(!parola.equals("uscita")){
				boolean palindroma = parolaPalindroma(parola);
				if(palindroma)
					System.out.println("La parola "+parola+" e' palindroma");
				else
					System.out.println("La parola "+parola+" non e' palindroma");
			}
		}while(!parola.equals("uscita"));
		System.out.println("Grazie per aver giocato!");
		tastiera.close();
		
	}
	
	/* prima versione del metodo
	 * 
	public static boolean parolaPalindroma(String parola){
		boolean palindroma = true;
		for(int i=0; i<parola.length()/2 && palindroma; i++)
			if(parola.charAt(i) != parola.charAt(parola.length()-1-i))
				palindroma=false;
		return palindroma;
	}
	*/
	
	// versione alternativa del metodo
	public static boolean parolaPalindroma(String parola){
		return parola.equals(invertiParola(parola));
		// se il metodo invertiParola fosse stato definito nella classe
		// StringReverse come in un esercizio precedente, la chiamata
		// sarebbe stata:
		// return parola.equals(StringReverse.invertiParola(parola));
	}
	
	// metodo di supporto
	public static String invertiParola(String s){
		String risultato = "";
		for(int i=s.length()-1; i>=0;i--)
			risultato += s.charAt(i);
		return risultato;
	}

}
